> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.sofer.ai/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.sofer.ai/_mcp/server.

# Update Timestamps

POST https://api.sofer.ai/v1/timestamps/update-timestamps
Content-Type: application/json

Update the timestamps based on edited text.

Reference: https://docs.sofer.ai/api-reference/timestamps/update-timestamps

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Body (application/json)

This endpoint expects an UpdateTimestampsRequest.

- `old_timestamps` (list of Timestamp, required) — The original timestamps associated with the text before editing. These will be used as reference points to align the new timestamps.
- `edited_text` (string, required) — The modified version of the transcription text that needs updated timestamp alignments. This should be the complete text after your edits.
- `language_to_update` (enum, optional) — If hebrew_word_format included both 'en' and 'he' (and therefor, for the same word there is both an English and a Hebrew version),this specifies which language version of the timestamps to update. Must be either 'en' for English or 'he' for Hebrew timestamps.
  - Allowed values: `en`, `he`, `yi`, `fr`

## Response

### 200

- `list of Timestamp`

## Errors

### 401 Authentication Error

Authentication error

### 429 Rate Limit Error

Rate limit exceeded, or you have used up your quota

## Types

### Timestamp

- `word` (string, required) — Word
- `start` (double, required) — Start time of the timestamp
- `end` (double, required) — End time of the timestamp
- `hebrew_word_format` (list of enum, optional) — Specifies the format of Hebrew words in the transcription. Hebrew words are denoted as "he" for Hebrew letters or "en" for English transliteration. Non-Hebrew words are represented by null.
  - Allowed values: `en`, `he`, `hybrid`
- `speaker` (string, optional) — If speaker labeling was requested, indicates which speaker number spoke this word (Pro feature)

## Examples

**Request**

```json
{
  "old_timestamps": [
    {
      "word": "word",
      "start": 1.1,
      "end": 1.1
    },
    {
      "word": "word",
      "start": 1.1,
      "end": 1.1
    }
  ],
  "edited_text": "edited_text"
}
```

**Response**

```json
[
  {
    "word": "word",
    "start": 1.1,
    "end": 1.1,
    "hebrew_word_format": [
      "en",
      "en"
    ],
    "speaker": "speaker"
  },
  {
    "word": "word",
    "start": 1.1,
    "end": 1.1,
    "hebrew_word_format": [
      "en",
      "en"
    ],
    "speaker": "speaker"
  }
]
```

**SDK Code**

```python
import requests

url = "https://api.sofer.ai/v1/timestamps/update-timestamps"

payload = {
    "old_timestamps": [
        {
            "word": "word",
            "start": 1.1,
            "end": 1.1
        },
        {
            "word": "word",
            "start": 1.1,
            "end": 1.1
        }
    ],
    "edited_text": "edited_text"
}
headers = {
    "Authorization": "Bearer <apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sofer.ai/v1/timestamps/update-timestamps';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <apiKey>', 'Content-Type': 'application/json'},
  body: '{"old_timestamps":[{"word":"word","start":1.1,"end":1.1},{"word":"word","start":1.1,"end":1.1}],"edited_text":"edited_text"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sofer.ai/v1/timestamps/update-timestamps"

	payload := strings.NewReader("{\n  \"old_timestamps\": [\n    {\n      \"word\": \"word\",\n      \"start\": 1.1,\n      \"end\": 1.1\n    },\n    {\n      \"word\": \"word\",\n      \"start\": 1.1,\n      \"end\": 1.1\n    }\n  ],\n  \"edited_text\": \"edited_text\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sofer.ai/v1/timestamps/update-timestamps")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"old_timestamps\": [\n    {\n      \"word\": \"word\",\n      \"start\": 1.1,\n      \"end\": 1.1\n    },\n    {\n      \"word\": \"word\",\n      \"start\": 1.1,\n      \"end\": 1.1\n    }\n  ],\n  \"edited_text\": \"edited_text\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sofer.ai/v1/timestamps/update-timestamps")
  .header("Authorization", "Bearer <apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"old_timestamps\": [\n    {\n      \"word\": \"word\",\n      \"start\": 1.1,\n      \"end\": 1.1\n    },\n    {\n      \"word\": \"word\",\n      \"start\": 1.1,\n      \"end\": 1.1\n    }\n  ],\n  \"edited_text\": \"edited_text\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sofer.ai/v1/timestamps/update-timestamps', [
  'body' => '{
  "old_timestamps": [
    {
      "word": "word",
      "start": 1.1,
      "end": 1.1
    },
    {
      "word": "word",
      "start": 1.1,
      "end": 1.1
    }
  ],
  "edited_text": "edited_text"
}',
  'headers' => [
    'Authorization' => 'Bearer <apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sofer.ai/v1/timestamps/update-timestamps");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"old_timestamps\": [\n    {\n      \"word\": \"word\",\n      \"start\": 1.1,\n      \"end\": 1.1\n    },\n    {\n      \"word\": \"word\",\n      \"start\": 1.1,\n      \"end\": 1.1\n    }\n  ],\n  \"edited_text\": \"edited_text\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "old_timestamps": [
    [
      "word": "word",
      "start": 1.1,
      "end": 1.1
    ],
    [
      "word": "word",
      "start": 1.1,
      "end": 1.1
    ]
  ],
  "edited_text": "edited_text"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sofer.ai/v1/timestamps/update-timestamps")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```